<script>
import { GlEmptyState, GlLoadingIcon } from '@gitlab/ui'
import getAffectingIssues from '@/apollo/queries/getAffectingIssues'

const AFFECTS_LABEL = 'Affects Product Data'

export default {
  name: 'StatusPage',

  components: { GlEmptyState, GlLoadingIcon },

  data() {
    return {
      groups: [
        {
          key: 'gitlabOrgIssues',
          fullPath: 'gitlab-org',
          labels: [AFFECTS_LABEL],
        },
        {
          key: 'gitlabDataIssues',
          fullPath: 'gitlab-data',
          labels: [AFFECTS_LABEL],
        },
      ],
      gitlabOrgIssues: [],
      gitlabDataIssues: [],
    }
  },

  head() {
    return {
      title: 'Status dashboard',
    }
  },

  computed: {
    issues() {
      return [...this.gitlabOrgIssues, ...this.gitlabDataIssues]
    },
  },

  mounted() {
    this.fetchGroupIssues()
  },

  methods: {
    fetchGroupIssues() {
      this.groups.forEach((group) => {
        this.$apollo.addSmartQuery(group.key, {
          query: getAffectingIssues,
          variables: {
            fullPath: group.fullPath,
            labelName: group.labels,
          },
          update: (data) => data?.group?.issues?.nodes ?? [],
        })
      })
    },
  },
}
</script>

<template>
  <div class="mx-auto max-w-4xl px-4 py-4 sm:px-6 lg:px-8">
    <h2 class="text-2xl font-semibold leading-7">Status dashboard</h2>
    <p class="mt-2 text-sm text-gray-500 sm:text-base">
      This is the list of issues that could currently affect Product
      Intelligence data. If you don't see an issue that relates to problems
      you're experiencing, please reach out to us via Slack on
      <md-external-link
        href="https://gitlab.slack.com/archives/CL3A7GFPF"
        label="#g_product_intelligence"
      />
      or
      <md-external-link
        href="https://gitlab.com/gitlab-org/product-intelligence/-/issues?sort=created_date&state=opened"
        label="create an issue"
      />. We also have a
      <md-external-link
        href="https://app.periscopedata.com/app/gitlab/968489/Product-Intelligence---Service-Ping-Health"
        label="Health Dashboard for Service Ping"
      />.
    </p>

    <div v-if="$apollo.loading" class="my-12 text-center">
      <gl-loading-icon size="md" />
      <span class="text-medium mt-2">Loading issues</span>
    </div>

    <div
      v-if="!$apollo.loading && issues.length"
      class="my-2 divide-y divide-gray-300 text-sm sm:text-base"
    >
      <md-issue v-for="issue in issues" :key="issue.id" :issue="issue" />
    </div>

    <gl-empty-state
      v-if="!$apollo.loading && !issues.length"
      class="my-12"
      title="We found no health-affecting issues"
      svg-path="https://gitlab.com/gitlab-org/gitlab-svgs/raw/v1.152.0/illustrations/security-dashboard-empty-state.svg"
      :svg-height="145"
    />
  </div>
</template>

<style>
.empty-state .svg-content img {
  display: inline;
}
</style>
